unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPServer, xmldom,
  XMLIntf, msxmldom, XMLDoc;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    XMLDocument1: TXMLDocument;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    IdTCPServer1: TIdTCPServer;
    procedure IdTCPServer1Disconnect(AThread: TIdPeerThread);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  dataxml: String;

implementation

{$R *.dfm}

procedure TForm1.IdTCPServer1Disconnect(AThread: TIdPeerThread);
begin
  Memo1.Lines.Add('Disconnect');
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
  Memo1.Lines.Add('Connect');
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  try
    IdTCPServer1.DefaultPort:=StrToInt(Edit2.Text); //nastaveni portu
  except
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  dataxml:=Edit1.Text; //nastaveni souboru s daty
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1Change(nil);
  Edit2Change(nil);
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
var
  pozadavek, adresa, parametry, 
  odkud, kam, pres: String;
  spojeni, odjezd, prestupy: Integer;
begin
  if not FileExists(dataxml) then //kdyz nejsou data
  begin
    Memo1.Lines.Add('Execute: Chyba: soubor s daty ('+dataxml+') neexistuje');
    AThread.Connection.Disconnect;
    Exit;
  end;

  Memo1.Lines.Add('Execute');
  pozadavek:=AThread.Connection.ReadLn(); //nacteni pozadavku
  Memo1.Lines.Add('Execute: Pozadavek: '+pozadavek);
  if (Copy(pozadavek,1,4)<>'GET ') then //kdyz to neni GET napis chybu
  begin
    Memo1.Lines.Add('Execute: Chyba: pozadavek neni GET');
    AThread.Connection.WriteLn('<Chyba>Neznamy pozadavek. Nebude zpracovan.</Chyba>');
    AThread.Connection.Disconnect;
    Exit;
  end;

  adresa:=Copy(pozadavek,5,Length(pozadavek)-4); //ziskani adresy z pozadavku
  adresa:=Copy(adresa,1,Pos(' ',adresa)-1);
  Memo1.Lines.Add('Execute: Adresa: '+adresa);

  if adresa='/SeznamStanic' then //poslani seznamu stanic
  begin
//nemam v programu xml, protoze se mi to nepodarilo udelat
{    Form1.XMLDocument1.LoadFromFile(dataxml);
//    Form1.XMLDocument1.Filename:=dataxml;
//    Form1.XMLDocument1.Active:=True;
    Form1.Memo1.Lines.Add(IntToStr(Form1.XMLDocument1.ChildNodes.IndexOf('Linky')));
}
    AThread.Connection.WriteLn('HTTP/1.0 200 OK');
    AThread.Connection.WriteLn();
    AThread.Connection.WriteLn('<SeznamStanic>');
    AThread.Connection.WriteLn('  <Stanice>Sazava u Zdaru,z.SaZ</Stanice>');
    AThread.Connection.WriteLn('  <Stanice>Nizkov-Nove Dvory</Stanice>');
    AThread.Connection.WriteLn('  <Stanice>Pribyslav,vlecka SaZ</Stanice>');
    AThread.Connection.WriteLn('</SeznamStanic>');
  end;

  if Pos('/NajdiSpojeni',adresa)=1 then //vyhledani spojeni
  begin
//nemam v programu xml, protoze se mi to nepodarilo udelat

    parametry:=Copy(adresa,pos('?',adresa)+1,Length(adresa)-pos('?',adresa));
    Memo1.Lines.Add('Execute: NajdiSpojeni: Parametry: '+parametry);
    while parametry<>'' do //zjisteni parametru
    begin
      if Copy(parametry,1,pos('=',parametry)-1)='odkud' then
      begin
        odkud:=Copy(parametry,pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1);
      end

      else if Copy(parametry,1,pos('=',parametry)-1)='kam' then
      begin
        kam:=Copy(parametry,pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1);
      end

      else if Copy(parametry,1,pos('=',parametry)-1)='pres' then
      begin
        pres:=Copy(parametry,Pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1);
      end

      else if Copy(parametry,1,pos('=',parametry)-1)='spojeni' then
      begin
        spojeni:=StrToInt(Copy(parametry,pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1));
      end

      else if Copy(parametry,1,pos('=',parametry)-1)='odjezd' then
      begin
        odjezd:=StrToInt(Copy(parametry,pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1));
      end

      else if Copy(parametry,1,pos('=',parametry)-1)='prestupy' then
      begin
        prestupy:=StrToInt(Copy(parametry,pos('=',parametry)+1,Pos('&',parametry)-Pos('=',parametry)-1));
      end;

      parametry:=Copy(parametry,pos('&',parametry)+1,Length(parametry)-Pos('&',parametry));
    end;

    while Pos('+',odkud)<>0 do //nahrazeni mezer
    begin
      odkud[Pos('+',odkud)]:=' ';
    end;
    while Pos('+',kam)<>0 do
    begin
      kam[Pos('+',kam)]:=' ';
    end;
    while Pos('+',pres)<>0 do
    begin
      pres[Pos('+',pres)]:=' ';
    end;

    Memo1.Lines.Add('Execute: NajdiSpojeni: Odkud: '+odkud);
    Memo1.Lines.Add('Execute: NajdiSpojeni: Kam: '+kam);
    Memo1.Lines.Add('Execute: NajdiSpojeni: Pres: '+pres);
    Memo1.Lines.Add('Execute: NajdiSpojeni: Spojeni: '+IntToStr(spojeni));
    Memo1.Lines.Add('Execute: NajdiSpojeni: Odjezd: '+IntToStr(odjezd));
    Memo1.Lines.Add('Execute: NajdiSpojeni: Prestupy: '+IntToStr(prestupy));


    AThread.Connection.WriteLn('HTTP/1.0 200 OK');
    AThread.Connection.WriteLn();
    AThread.Connection.WriteLn('<Spojeni>');
    AThread.Connection.WriteLn('  <Spoj>');
    AThread.Connection.WriteLn('    <Linka cislo="R123">');
    AThread.Connection.WriteLn('      <Stanice odjezd="'+IntToStr(odjezd)+'">'+odkud+'</Stanice>');
    if pres<>'' then
      AThread.Connection.WriteLn('      <Stanice prijezd="'+IntToStr(odjezd+10)+'" odjezd="'+IntToStr(odjezd+20)+'">'+pres+'</Stanice>');
    AThread.Connection.WriteLn('      <Stanice prijezd="'+IntToStr(odjezd+30)+'" odjezd="'+IntToStr(odjezd+40)+'">'+kam+'</Stanice>');
    AThread.Connection.WriteLn('    </Linka>');
    AThread.Connection.WriteLn('  </Spoj>');
    AThread.Connection.WriteLn('</Spojeni>');
  end;

  AThread.Connection.Disconnect; //odpojeni
end;

end.
